#include <iostream>
using namespace std;

class FuncoesEspeciais {
  
   // os objetos de uma classe friend podem acessar membros
   // private e protected
  friend class Externa;
  
  private:
      double buffer;
      void clearBuffer();
  public:
      void setBuffer(double pValue);
      double mult(double pValue);
	// nao pertence a classe Funcoes Especiais
	// eh marcada como 'amiga' da classe e por isso pode
	// acessar os membros protected/private
	friend double getBufferFromOutside(FuncoesEspeciais fe);
};

double getBufferFromOutside(FuncoesEspeciais fe) {
   double temp = fe.buffer;
   fe.buffer = 0;
   return temp;
}

void FuncoesEspeciais::setBuffer(double pValue) {
    buffer = pValue;
}

// dica para o compilador inserir os comandos internos
// do metodo ou funcao, no local onde foi chamado
inline double FuncoesEspeciais::mult(double pValue) {
    // comando 1
    // comando 2
    // comando 3
    // comando 4
    // comando 5
    return (buffer * pValue);
}

void FuncoesEspeciais::clearBuffer() {
    buffer = 0;
}

class Externa {
   public:
	double getBufferFromExterna(FuncoesEspeciais fe);
};

double Externa::getBufferFromExterna(FuncoesEspeciais fe) {
   // Externa eh friend de FuncoesEspeciais 
   // por isso tem acesso aos metodos e atributos private
   double temp = fe.buffer; // atributo private
   fe.clearBuffer(); // metodo private
   return temp;
}


int main (int argc, char *argv[]) 
{
  
   FuncoesEspeciais *fe = new FuncoesEspeciais();
   
   fe->mult(5);  // (buffer * 5) compilador pode copiar comando aqui
   fe->mult(2);  // (buffer * 2)
   fe->mult(1);  // (buffer * 1)
   fe->mult(2);  // (buffer * 2)
   fe->mult(3);  // (buffer * 3)
   
   fe->setBuffer(3);
   
   cout << "Buffer (via funcao friend) = " 
        << getBufferFromOutside(*fe) << endl;

   fe->setBuffer(9);
 
   Externa ex;
    
   cout << "Buffer (via classe friend) = " 
         << ex.getBufferFromExterna(*fe) << endl;
 

   return 0;
  
}
