#include <iostream>
using namespace std;

class CPolygon {
  protected:
    int width, height;
  public:
    void set_values (int a, int b) {
       width=a; height=b; 
    }
    // virtual pode ser redefinido em diversas classes derivadas
    // e como se na classe CPolygon esse metodo nao fosse util
    virtual int area () {
       return 0;
    }
};

class CRectangle: public CPolygon {
  public:
    // metodo sobrecarregado (override))
    int area ()
      { return (width * height); }
};

class CTriangle: public CPolygon {
  public:
    // metodo sobrecarregado (override))
    int area ()
      { return (width * height / 2); }
};

int main (int argc, char *argv[]) {
  CRectangle rect;
  CTriangle trgl;
  CPolygon poly;
  CPolygon * ppoly1 = &rect;
  CPolygon * ppoly2 = &trgl;
  CPolygon * ppoly3 = &poly;
  ppoly1->set_values (4,5); // metodo herdado
  ppoly2->set_values (4,5); // metodo herdado
  ppoly3->set_values (4,5); // metodo herdado

  // area e virtual, e portanto
  // em tempo de compilacao nao e possivel saber
  // se o metodo area provem do objeto Polygon, Rectangle ou Triangle
  // dynamical binding - resolvido em tempo de execucao
  cout << ppoly1->area() << endl;
  cout << ppoly2->area() << endl;
  cout << ppoly3->area() << endl;
  
  // static binding - resolvido em tempo de compilacao
  CRectangle * prect = &rect;
  cout << prect->area() << endl;
  
  return 0;
}